import pygame
import random

pygame.init()

###Color Initialization, Set Clock, and Running###
white = (255, 255, 255)
black = (0, 0, 0)
red = (255, 0, 0)
blue = (0,0,255)
green = (0,255,0)

startMenu = True
running = True
clock = pygame.time.Clock()

###Window Resolution###
screenX=400
screenY=300

gameDisplay = pygame.display.set_mode((screenX,screenY))
pygame.display.set_caption("Snek")


###Define Classes and Functions###
class vector2D:
	x = 0
	y = 0
	xy = (x,y)

class snake:
	x = int(screenX/2)
	y = int(screenY/2)
	width = 10
	height = 10
	speed = 10
	xSpeed = speed
	ySpeed = 0
	
	length = 1
	tail = []

class apple:
	x = round(random.randrange(10, screenX - 10),-1)
	y = round(random.randrange(10, screenY - 10),-1)
	width = 10
	height = 10
	
	
def addTail():
	snake.tail.append(vector2D()) 
	snake.length = len(snake.tail)

	snake.tail[len(snake.tail)-1].xy = (snake.x, snake.y)

def printTail():
	for i in snake.tail:
		print(i.xy)
	
def tailFollow():
	tailTemp = snake.tail [:]
	for i in range(0, len(snake.tail)):
		tailTemp[i-1] = snake.tail[i]
		tailTemp[len(tailTemp)-1].xy = (snake.x, snake.y)
	return tailTemp

def closeGame():
	print("Game Over")
	pygame.quit()
	quit()
	
def collision(x1,y1,w1,h1,x2,y2,w2,h2):
	if (x2+w2>=x1>=x2 and y2+h2>=y1>=y2):
		return True
	elif (x2+w2>=x1+w1>=x2 and y2+h2>=y1>=y2):
		return True 
	elif (x2+w2>=x1>=x2 and y2+h2>=y1+h1>=y2):
		return True
	elif (x2+w2>=x1+w1>=x2 and y2+h2>=y1+h1>=y2):
		return True
	else:
		return False

###Start Menu###
while startMenu:
	pygame.display.update()
	clock.tick(15)
	gameDisplay.fill(white)

	basicfont = pygame.font.SysFont(None, 48)
	text = basicfont.render('Snek!', True, green, white)
	textrect = text.get_rect()
	textrect.centerx = int(screenY/2)
	textrect.centery = int(screenX/2)
	gameDisplay.blit(text, textrect)

	for event in pygame.event.get():
		if event.type == pygame.KEYDOWN:
			startMenu = False

###Start Game###
while running:
	###Event Handler###
	for event in pygame.event.get():
		#print(event)
		if event.type == pygame.QUIT:
			running = False
		
		###Keyboard Controls###
		if event.type == pygame.KEYDOWN:
			if event.key == pygame.K_LEFT and snake.xSpeed != snake.speed:
				snake.xSpeed = -1*snake.speed
				snake.ySpeed = 0
			elif event.key == pygame.K_RIGHT and snake.xSpeed != -1*snake.speed:
				snake.xSpeed = snake.speed
				snake.ySpeed = 0
			elif event.key == pygame.K_UP and snake.ySpeed != snake.speed:
				snake.ySpeed = -1*snake.speed
				snake.xSpeed = 0
			elif event.key == pygame.K_DOWN and snake.ySpeed != -1*snake.speed:
				snake.ySpeed = snake.speed
				snake.xSpeed = 0

	###Hitting a wall causes game over###
	if snake.x >= screenX or snake.y >= screenY or snake.x < 0 or snake.y < 0:
		running = False
	
	###Eating an apple spawns a new apple and increases snake length###
	if collision(snake.x+1, snake.y+1, snake.width-1, snake.height-1, apple.x+1, apple.y+1, apple.width-1, apple.height-1):
		apple.x = round(random.randrange(10, screenX - 10),-1)
		apple.y = round(random.randrange(10, screenY - 10),-1)

		
		if len(snake.tail) < 1:
			addTail()
		addTail()
		
	###Hitting yourself causes game over
	for body in range(0,len(snake.tail)-2):
		if collision(snake.x-5,snake.y-5,snake.width-5,snake.height-5,snake.tail[body].xy[0]-5,snake.tail[body].xy[1]-5,snake.width-5, snake.height-5):
			print("Ded.")
			running = False
	
	###Update Player Position###
	snake.x += snake.xSpeed
	snake.y += snake.ySpeed
	
	snake.tail = tailFollow()
	
	###Draw BG, Snake, Apple###
	gameDisplay.fill(white)
	
	pygame.draw.rect(gameDisplay, black, [snake.x,snake.y,snake.width,snake.height])
	if snake.length > 0:
		for i in range (0, int(snake.length)-1):
			pygame.draw.rect(gameDisplay, green, [snake.tail[i].xy[0], snake.tail[i].xy[1],snake.width,snake.height])
	
	pygame.draw.rect(gameDisplay, red, [apple.x, apple.y, apple.width, apple.height])
	
	###Update Frame and Clock###
	pygame.display.update()
	clock.tick(15)

closeGame()
